

            LIST      P=16F84
            include "P16F84a.inc"	; 4.000 MHz
	__CONFIG _CP_OFF & _WDT_OFF & _PWRTE_ON& _XT_OSC

            ORG     0x0000

            CALL    init_reg
            CLRF    PORTA
            GOTO    start

            ORG     0x0004
            GOTO    int_save

            ORG     0x0005
            RETLW   'n'			; 0x05
            RETLW   'F'			; 
            RETLW   0x00		; end
            RETLW   'p'			; 0x08
            RETLW   'F'			; 
            RETLW   0x00		; end
            RETLW   'm'			; 0x0B
            RETLW   'H'			; 
            RETLW   0x00		; end
            RETLW   'u'			; 0x0E
            RETLW   'H'			; 
            RETLW   0x00		; end
            RETLW   'C'			; 0x11
            RETLW   '='			; 
            RETLW   0x00		; end
            RETLW   'L'			; 0x14
            RETLW   '='			; 
            RETLW   0x00		; end
            RETLW   'W'			; 0x17
            RETLW   'A'		
            RETLW   'I'		
            RETLW   'T'		
            RETLW   0x00		; end
            RETLW   'O'			; 0x1C
            RETLW   'K'			; 
            RETLW   0x00		; end
start
	    BSF     PORTA     , 00
            CALL    init_lcd
            BCF     INTCON    , T0IF
            BSF     INTCON    , T0IE
            BSF     INTCON    , GIE

main
            CALL    cursor_home
            BTFSS   PORTB     , 07
            GOTO    mode
            BTFSS   PORTB     , 06
            GOTO    mode
	    call    clear_lcd
	    goto    calibration
mode
            CALL    go_count
            BTFSC   0x41      , 04
	    goto    main
	    movlw   'C'			; C
	    BTFSS   PORTB     , 07
	    movlw   'L'			; L
            CALL    send_data
            GOTO    main
calibration

	call    clear_lcd
	MOVLW   0x17		; 'WAIT'
        CALL    read_wchar
	
	clrf	0x40
	clrf	0x39

	incf	0x39,f
	CALL	delay_2xbig2
	btfss	0x39,4
	goto	$-3


	    CALL    go_count
            CALL    delay_big2
            CALL    delay_2xbig2
            CALL    go_count
            MOVF    0x2F      , W
            MOVWF   0x2B
            MOVF    0x30      , W
            MOVWF   0x2C
            BCF     PORTA     , 00
            CALL    delay_2xbig2
            CALL    delay_2xbig2
            CALL    delay_2xbig2
            CALL    delay_2xbig2
            CALL    delay_2xbig2
            CALL    delay_2xbig2
            CALL    go_count
            MOVF    0x2F      , W
            MOVWF   0x2D
            MOVF    0x30      , W
            MOVWF   0x2E
            BSF     PORTA     , 00
            CALL    delay_2xbig2
            CALL    clear_lcd
            MOVLW   0x1C		; 'OK'
            CALL    read_wchar
meter
            BTFSC   PORTB     , 07
            BTFSS   PORTB     , 06
	    goto $+6
	    btfsc	0x40, 07
	    goto	calibration
	    incf	0x40
            CALL    delay_2xbig2
	    goto meter


	    CALL    cursor_home
            CALL    go_count
            MOVF    0x2F      , W
            BTFSS   STATUS    , Z
            GOTO    C_meter
	    clrf    0x32
	    clrf    0x33
	    clrf    0x34
            CALL    clear_lcd
	    MOVLW   0x14		; 'L='
            CALL    read_wchar
            GOTO    meter

C_meter
	    CALL    Label_0010
            CALL    Label_0011

	    movlw   0xf0
	    movwf   0x40

            BTFSS   PORTB     , 07
            GOTO    L_meter
            MOVLW   0x11		; 'C='
            CALL    read_wchar
	    CALL    set_pos
            CALL    Label_0013
            CALL    dysp_C
            GOTO    meter
L_meter
	    MOVLW   0x14		; 'L='
            CALL    read_wchar
   	    CALL    set_pos
            CALL    Label_0015
            CALL    dysp_L 
           GOTO    meter
read_wchar
	    MOVWF   EEADR
read_fchar
	    MOVF    EEADR     , W
            CALL    get_char
            ANDLW   0xFF
            BTFSC   STATUS    , Z
            GOTO    exit_here
            CALL    send_data
            INCF    EEADR     , f
            GOTO    read_fchar
get_char
	    MOVWF   PCL
            NOP
exit_here
	    RETURN
delay_1
	    MOVLW   0xFD		; 
            MOVWF   0x28
            MOVLW   0x66
            MOVWF   0x29
            GOTO    delay_x
delay_2xbig2
	    CALL    delay_big2
delay_big2
	    MOVLW   0x7e		; 
            MOVWF   0x28
            MOVLW   0x21
            MOVWF   0x29
delay_x
	    INCFSZ  0x29      , f	;
            GOTO    delay_x
            INCFSZ  0x28      , f
            GOTO    delay_x
            RETLW   0x00

send_half
	    ANDLW   0x0F
            MOVWF   PORTB
            BSF     PORTA     , 02
            NOP
            BCF     PORTA     , 02
delay_200
	    MOVLW   0x42
            MOVWF   0x28
loop
	    DECFSZ  0x28      , f
            GOTO    loop
            RETLW   0x00

bin2bcd
	    MOVLW   0x18
            MOVWF   0x26
            CLRF    0x31
            CLRF    0x32
            CLRF    0x33
            CLRF    0x34
adjust  MOVLW   0x31
            MOVWF   FSR
            MOVLW   0x04
            MOVWF   0x27
adjbcd  MOVLW   0x33
            ADDWF   INDF      , f
            BTFSC   INDF      , 03
            ANDLW   0xF0
            BTFSC   INDF      , 07
            ANDLW   0x0F
            SUBWF   INDF      , f
            INCF    FSR       , f
            DECFSZ  0x27      , f
            GOTO    adjbcd
            RLF     0x11      , f
            RLF     0x12      , f
            RLF     0x13      , f
            RLF     0x34      , f
            RLF     0x33      , f
            RLF     0x32      , f
            RLF     0x31      , f
            DECFSZ  0x26      , f
            GOTO    adjust
            RETURN

init_lcd
	    CALL    delay_big2
            BCF     PORTA     , 02
            BCF     PORTA     , 01
            MOVLW   0x03
            CALL    send_half
            CALL    delay_big2
            MOVLW   0x03
            CALL    send_half
            MOVLW   0x03
            CALL    send_half
            MOVLW   0x02
            CALL    send_half
            MOVLW   0x0C
            CALL    send_cmd
            CALL    delay_200
            MOVLW   0x06
            CALL    send_cmd
            CALL    delay_200
            MOVLW   0x01
            CALL    send_cmd
            CALL    delay_1
            GOTO    clear_lcd


set_pos
	movlw	0x88
send_cmd
	    BCF     PORTA     , 01
            GOTO    send_byte

send_char  ANDLW   0x0F
            ADDLW   0x30

send_data  BSF     PORTA     , 01

send_byte
	    MOVWF   0x2A
            SWAPF   0x2A      , W
            CALL    send_nibble
            MOVF    0x2A      , W
send_nibble
	    ANDLW   0x0F
            MOVWF   PORTB
            BSF     PORTA     , 02
            NOP
            BCF     PORTA     , 02
            GOTO    delay_200

clear_lcd
	    MOVLW   0x01
            GOTO    send_long
cursor_home
	    MOVLW   0x02
send_long
	    CALL    send_cmd
            GOTO    delay_1		; at least 4.1 msec

init_reg
	    BSF     STATUS    , RP0
            MOVLW   b'00110111'		; pull up on
            MOVWF   OPTION_reg
            MOVLW   b'00010000'
            MOVWF   TRISA
            MOVLW   b'11110000'
            MOVWF   TRISB
            BCF     STATUS    , RP0
            RETURN
go_count
            BCF     0x41      , 04
            CLRF    TMR0
            BSF     PORTA     , 03
            CLRF    0x2F
            CLRF    0x30
            BSF     STATUS    , RP0
            MOVLW   b'00011000'
            MOVWF   TRISA
            BCF     STATUS    , RP0
            CALL    delay_big2
            BSF     STATUS    , RP0
            MOVLW   b'00010000'
            MOVWF   TRISA
            BCF     STATUS    , RP0
            MOVF    TMR0      , W
            MOVWF   0x2F

Label_0027  BSF     STATUS    , RP0
            BSF     OPTION_REG, T0SE
            NOP
            BCF     OPTION_REG, T0SE
            BCF     STATUS    , RP0
            DECF    0x30      , f
            MOVF    TMR0      , W
            XORWF   0x2F      , W
            BTFSC   STATUS    , Z
            GOTO    Label_0027
            RETURN

dysp_C  MOVF    0x31      , W
            ANDLW   0x0F
            BTFSC   STATUS    , Z
            GOTO    Label_002A
            CALL    send_char
            SWAPF   0x32      , W
            CALL    send_char
            MOVF    0x32      , W
            CALL    send_char
            MOVLW   0x2E
            CALL    send_data
            SWAPF   0x33      , W
            GOTO    Label_002B

Label_002A  SWAPF   0x32      , W
            ANDLW   0x0F
            BTFSC   STATUS    , Z
            GOTO    Label_002C
            CALL    send_char
            MOVF    0x32      , W
            CALL    send_char
            MOVLW   0x2E
            CALL    send_data
            SWAPF   0x33      , W
            CALL    send_char
            MOVF    0x33      , W
            GOTO    Label_002B

Label_002C  MOVF    0x32      , W
            ANDLW   0x0F
            BTFSC   STATUS    , Z
            GOTO    Label_002D
            CALL    send_char
            MOVLW   0x2E
            CALL    send_data
            SWAPF   0x33      , W
            CALL    send_char
            MOVF    0x33      , W
            CALL    send_char
            SWAPF   0x34      , W

Label_002B  CALL    send_char
            MOVLW   0x05
            GOTO    read_wchar		; _nF

Label_002D  SWAPF   0x33      , W
            ANDLW   0x0F
            BTFSS   STATUS    , Z
            GOTO    Label_002E
            MOVLW   0x20
            CALL    send_data
            MOVF    0x33      , W
            ANDLW   0x0F
            BTFSS   STATUS    , Z
            GOTO    Label_002F
            MOVLW   0x20
            CALL    send_data
            GOTO    Label_0030

Label_002E  SWAPF   0x33      , W
            CALL    send_char
Label_002F  MOVF    0x33      , W
            CALL    send_char
Label_0030  SWAPF   0x34      , W
            CALL    send_char
            MOVLW   0x2E
            CALL    send_data
            MOVF    0x34      , W
            CALL    send_char
            MOVLW   0x08
            GOTO    read_wchar		; _pF
dysp_L  MOVF    0x31      , W
            ANDLW   0x0F
            BTFSC   STATUS    , Z
            GOTO    Label_0031
            CALL    send_char
            SWAPF   0x32      , W
            CALL    send_char
            MOVLW   0x2E
            CALL    send_data
            MOVF    0x32      , W
            CALL    send_char
            SWAPF   0x33      , W
            GOTO    Label_0032
Label_0031  SWAPF   0x32      , W
            ANDLW   0x0F
            BTFSC   STATUS    , Z
            GOTO    Label_0033
            CALL    send_char
            MOVLW   0x2E
            CALL    send_data
            MOVF    0x32      , W
            CALL    send_char
            SWAPF   0x33      , W
            CALL    send_char
            MOVF    0x33      , W
Label_0032  CALL    send_char
            MOVLW   0x0B
            GOTO    read_wchar		; _mH
Label_0033  MOVF    0x32      , W
            ANDLW   0x0F
            BTFSC   STATUS    , Z
            GOTO    Label_0034
            CALL    send_char
            SWAPF   0x33      , W
            CALL    send_char
            MOVF    0x33      , W
            CALL    send_char
            MOVLW   0x2E
            CALL    send_data
            SWAPF   0x34      , W
            GOTO    Label_0035
Label_0034  SWAPF   0x33      , W
            ANDLW   0x0F
            BTFSS   STATUS    , Z
            GOTO    Label_0036
            MOVLW   0x20
            CALL    send_data
            GOTO    Label_0037
Label_0036  SWAPF   0x33      , W
            CALL    send_char
Label_0037  MOVF    0x33      , W
            CALL    send_char
            MOVLW   0x2E
            CALL    send_data
            SWAPF   0x34      , W
            CALL    send_char
            MOVF    0x34      , W
Label_0035  CALL    send_char
            MOVLW   0x0E
            GOTO    read_wchar		; _uH

int_save  
	    MOVWF   0x36
            SWAPF   STATUS    , W
            MOVWF   0x37
            BTFSC   INTCON    , T0IF
            BSF     0x41      , 04
            BCF     INTCON    , T0IF
            SWAPF   0x37      , W
            MOVWF   STATUS
            SWAPF   0x36      , f
            SWAPF   0x36      , W
            BCF     INTCON    , T0IF
            RETFIE


sub_v19
	    CALL    FPS24
            GOTO    copy21v19

div_v19
	    CALL    FPD24
            GOTO    copy21v19

mul_v19
	    CALL    FPM24


copy21v19
	    MOVF    0x21      , W
            MOVWF   0x19
            MOVF    0x22      , W
            MOVWF   0x1A
            MOVF    0x24      , W
            MOVWF   0x1B
            RETURN

copy19v21_12v19
	    MOVF    0x19      , W
            MOVWF   0x21
            MOVF    0x1A      , W
            MOVWF   0x22
            MOVF    0x1B      , W
            MOVWF   0x24
            MOVF    0x12      , W
            MOVWF   0x19
            MOVF    0x13      , W
            MOVWF   0x1A
            MOVF    0x14      , W
            MOVWF   0x1B
            RETURN

copy12v19_19v12
	    MOVF    0x12      , W
            MOVWF   EEADR
            MOVF    0x19      , W
            MOVWF   0x12
            MOVF    EEADR     , W
            MOVWF   0x19
            MOVF    0x13      , W
            MOVWF   EEADR
            MOVF    0x1A      , W
            MOVWF   0x13
            MOVF    EEADR     , W
            MOVWF   0x1A
            MOVF    0x14      , W
            MOVWF   EEADR
            MOVF    0x1B      , W
            MOVWF   0x14
            MOVF    EEADR     , W
            MOVWF   0x1B
            RETURN

Label_0013  CALL    div_v19
            CALL    set918v12
            CALL    mul_v19
            GOTO    Label_003F

Label_0015  CALL    mul_v19
            CALL    set1122v12
            CALL    mul_v19
            CALL    Label_0041
            CALL    copy19v21_12v19
            CALL    mul_v19
            CALL    copy12v19_19v12
            CALL    div_v19

Label_003F  BTFSS   0x13      , 07
            GOTO    Label_0044
            MOVLW   0x2D
            GOTO    Label_0045

Label_0044  MOVLW   0x20
Label_0045  CALL    send_data
            BCF     0x13      , 07
            CALL    INT2424
            GOTO    bin2bcd

Label_0011  CALL    Label_0047
            GOTO    Label_0048

Label_0010  CALL    Label_0049

Label_0048  CALL    Label_0041
            CALL    div_v19
            CALL    copy19v21_12v19
            CALL    mul_v19
            CALL    Label_004A		; 1 v float v12
            CALL    copy12v19_19v12
            GOTO    sub_v19

set1122v12
	    CALL    copy19v21_12v19
            MOVLW   0xAB
            MOVWF   0x14
            MOVLW   0x38
            MOVWF   0x13
            MOVLW   0x4D
            GOTO    Label_004C

set918v12
	    CALL    copy19v21_12v19
            MOVLW   0x8C
            MOVWF   0x14
            MOVLW   0x1C
            MOVWF   0x13
            MOVLW   0x40
Label_004C  MOVWF   0x12
            RETURN

Label_004A  CALL    copy19v21_12v19
            CLRF    0x14
            CLRF    0x13
            CLRF    0x12
            MOVLW   0x01
            GOTO    Label_004D

Label_0041  MOVLW   0x2B
            GOTO    Label_004E

Label_0049  MOVLW   0x2D
            GOTO    Label_004E

Label_0047  MOVLW   0x2F
Label_004E  MOVWF   FSR
            CALL    copy19v21_12v19
            CLRF    0x14
            CLRF    0x13
            MOVF    INDF      , W
            MOVWF   0x12
            INCF    FSR       , f
            MOVF    INDF      , W
Label_004D  MOVWF   0x11
            GOTO    FLO2424

NRM2424
	    CLRF    0x1F
            MOVF    0x13      , W
            BTFSS   STATUS    , Z
            GOTO    NORM2424
            MOVF    0x12      , W
            MOVWF   0x13
            BTFSC   STATUS    , Z
            GOTO    RES024
            CLRF    0x12
            BSF     0x1F      , 03
NORM2424
	    MOVF    0x1F      , W
            SUBWF   0x14      , f
            BTFSS   STATUS    , Z
            BTFSS   STATUS    , C
            GOTO    SETFUN24
            BCF     STATUS    , C
NORM2424A
	    BTFSC   0x13      , 07
            GOTO    FIXSIGN24
            RLF     0x12      , f
            RLF     0x13      , f
            DECFSZ  0x14      , f
            GOTO    NORM2424A
            GOTO    SETFUN24
FIXSIGN24
	    BTFSS   0x15      , 07
            BCF     0x13      , 07
            RETLW   0x00

RES024
	    CLRF    0x13
            CLRF    0x12
            CLRF    0x11
            CLRF    0x14
            RETLW   0x00

FLO2424
	    MOVLW   0x96
            MOVWF   0x14
            CLRF    0x15
            BTFSS   0x13      , 07
            GOTO    NRM3224
            COMF    0x11      , f
            COMF    0x12      , f
            COMF    0x13      , f
            INCF    0x11      , f
            BTFSC   STATUS    , Z
            INCF    0x12      , f
            BTFSC   STATUS    , Z
            INCF    0x13      , f
            BSF     0x15      , 07

NRM3224
	    CLRF    0x1F
            MOVF    0x13      , W
            BTFSS   STATUS    , Z
            GOTO    NORM3224
            MOVF    0x12      , W
            MOVWF   0x13
            MOVF    0x11      , W
            MOVWF   0x12
            CLRF    0x11
            BSF     0x1F      , 03

            MOVF    0x13      , W
            BTFSS   STATUS    , Z
            GOTO    NORM3224
            MOVF    0x12      , W
            MOVWF   0x13
            CLRF    0x12
            BCF     0x1F      , 03
            BSF     0x1F      , 04
            MOVF    0x13      , W
            BTFSC   STATUS    , Z
            GOTO    RES024
NORM3224
	    MOVF    0x1F      , W
            SUBWF   0x14      , f
            BTFSS   STATUS    , Z
            BTFSS   STATUS    , C
            GOTO    SETFUN24

            BCF     STATUS    , C

NORM3224A
	    BTFSC   0x13      , 07
            GOTO    NRMRND3224
            RLF     0x11      , f
            RLF     0x12      , f
            RLF     0x13      , f
            DECFSZ  0x14      , f
            GOTO    NORM3224A
            GOTO    SETFUN24
NRMRND3224
	    BTFSC   0x16      , 06
            BTFSS   0x12      , 00
            GOTO    FIXSIGN24
            BTFSS   0x11      , 07
            GOTO    FIXSIGN24
            INCF    0x12      , f
            BTFSC   STATUS    , Z
            INCF    0x13      , f

            BTFSS   STATUS    , Z
            GOTO    FIXSIGN24
            RRF     0x13      , f
            RRF     0x12      , f
            INCF    0x14      , f
            BTFSC   STATUS    , Z
            GOTO    SETFOV24
            GOTO    FIXSIGN24

INT2424
	    CLRF    0x11
            MOVF    0x14      , W
            BTFSC   STATUS    , Z
            RETLW   0x00

            MOVF    0x13      , W
            MOVWF   0x15
            BSF     0x13      , 07
            MOVLW   0x96
            SUBWF   0x14      , f
            BTFSS   0x14      , 07
            GOTO    SETIOV24
            COMF    0x14      , f
            INCF    0x14      , f

            MOVLW   0x08
            SUBWF   0x14      , W
            BTFSS   STATUS    , C
            GOTO    TSHIFT2424
            MOVWF   0x14
            RLF     0x11      , f
            MOVF    0x12      , W
            MOVWF   0x11
            MOVF    0x13      , W
            MOVWF   0x12
            CLRF    0x13

            MOVLW   0x08
            SUBWF   0x14      , W
            BTFSS   STATUS    , C
            GOTO    TSHIFT2424
            MOVWF   0x14
            RLF     0x11      , f
            MOVF    0x12      , W
            MOVWF   0x11
            CLRF    0x12

            MOVLW   0x08
            SUBWF   0x14      , W
            BTFSS   STATUS    , C
            GOTO    TSHIFT2424
            MOVWF   0x14
            RLF     0x11      , f
            CLRF    0x11
            MOVF    0x14      , W
            BTFSS   STATUS    , Z
            BCF     STATUS    , C
            GOTO    SHIFT2424OK

TSHIFT2424
	    MOVF    0x14      , W
            BTFSC   STATUS    , Z
            GOTO    SHIFT2424OK
SHIFT2424
	    BCF     STATUS    , C
            RRF     0x13      , f
            RRF     0x12      , f
            RRF     0x11      , f
            DECFSZ  0x14      , f
            GOTO    SHIFT2424
SHIFT2424OK
	    BTFSC   0x16      , 06
            BTFSS   0x11      , 00
            GOTO    INT2424OK
            BTFSS   STATUS    , C
            GOTO    INT2424OK
            INCF    0x11      , f
            BTFSC   STATUS    , Z
            INCF    0x12      , f
            BTFSC   STATUS    , Z
            INCF    0x13      , f
            BTFSC   0x13      , 07
            GOTO    SETIOV24
INT2424OK
	    BTFSS   0x15      , 07
            RETLW   0x00
            COMF    0x13      , f
            COMF    0x12      , f
            COMF    0x11      , f
            INCF    0x11      , f
            BTFSC   STATUS    , Z
            INCF    0x12      , f
            BTFSC   STATUS    , Z
            INCF    0x13      , f
            RETLW   0x00
            CLRF    0x13
            CLRF    0x12
            CLRF    0x11
            RETLW   0x00

SETIOV24
	    BSF     0x16      , 00
            BTFSS   0x16      , 07
            RETLW   0xFF
            CLRF    0x13
            BTFSS   0x15      , 07
            MOVLW   0xFF
            MOVWF   0x13
            MOVWF   0x12
            MOVWF   0x11
            RLF     0x15      , f
            RRF     0x13      , f
            RETLW   0xFF

FPM24
	    MOVF    0x14      , W
            BTFSS   STATUS    , Z
            MOVF    0x1B      , W
            BTFSC   STATUS    , Z
            GOTO    RES024

            MOVF    0x13      , W
            XORWF   0x1A      , W
            MOVWF   0x15

            MOVF    0x1B      , W
            ADDWF   0x14      , f
            MOVLW   0x7E
            BTFSS   STATUS    , C
            GOTO    MTUN24

            SUBWF   0x14      , f
            BTFSC   STATUS    , C
            GOTO    SETFOV24
            GOTO    MOK24
MTUN24
	    SUBWF   0x14      , f
            BTFSS   STATUS    , C
            GOTO    SETFUN24
MOK24
	    MOVF    0x13      , W
            MOVWF   0x11
            MOVF    0x12      , W
            MOVWF   0x10
            BSF     0x11      , 07
            BSF     0x1A      , 07
            BCF     STATUS    , C
            CLRF    0x13
            CLRF    0x12
            MOVLW   0x10
            MOVWF   0x1F

MLOOP24  
	    BTFSS   0x10      , 00
            GOTO    MNOADD24

            MOVF    0x19      , W
            ADDWF   0x12      , f
            MOVF    0x1A      , W
            BTFSC   STATUS    , C
            INCFSZ  0x1A      , W
            ADDWF   0x13      , f
MNOADD24
	    RRF     0x13      , f
            RRF     0x12      , f
            RRF     0x11      , f
            RRF     0x10      , f
            BCF     STATUS    , C
            DECFSZ  0x1F      , f
            GOTO    MLOOP24
            BTFSC   0x13      , 07
            GOTO    MROUND24
            RLF     0x11      , f
            RLF     0x12      , f
            RLF     0x13      , f
            DECF    0x14      , f
MROUND24
	    BTFSC   0x16      , 06
            BTFSS   0x12      , 00
            GOTO    MUL24OK
            BTFSS   0x11      , 07
            GOTO    MUL24OK
            INCF    0x12      , f
            BTFSC   STATUS    , Z
            INCF    0x13      , f
            BTFSS   STATUS    , Z
            GOTO    MUL24OK
            RRF     0x13      , f
            RRF     0x12      , f
            INCF    0x14      , f
            BTFSC   STATUS    , Z
            GOTO    SETFOV24
MUL24OK
	    BTFSS   0x15      , 07
            BCF     0x13      , 07
            RETLW   0x00

SETFOV24
	    BSF     0x16      , 01
            BTFSS   0x16      , 07
            RETLW   0xFF
          
    	    MOVLW   0xFF
            MOVWF   0x14
            MOVWF   0x13
            MOVWF   0x12
            RLF     0x15      , f
            RRF     0x13      , f
            RETLW   0xFF

FPD24
	    MOVF    0x1B      , W
            BTFSC   STATUS    , Z
            GOTO    SETFDZ24

            MOVF    0x14      , W
            BTFSC   STATUS    , Z
            GOTO    RES024

            MOVF    0x13      , W
            XORWF   0x1A      , W
            MOVWF   0x15
            BSF     0x13      , 07
            BSF     0x1A      , 07

            CLRF    0x1F
            MOVF    0x13      , W
            MOVWF   0x11
            MOVF    0x12      , W
            MOVWF   0x10

            MOVF    0x19      , W
            SUBWF   0x10      , f
            MOVF    0x1A      , W
            BTFSS   STATUS    , C
            INCFSZ  0x1A      , W
            SUBWF   0x11      , f

            CLRF    0x11
            CLRF    0x10

            BTFSS   STATUS    , C
            GOTO    DALIGN24OK

            BCF     STATUS    , C
            RRF     0x13      , f
            RRF     0x12      , f
            RRF     0x11      , f
            MOVLW   0x01
            MOVWF   0x1F
DALIGN24OK
	    MOVF    0x1B      , W
            SUBWF   0x14      , f
            BTFSS   STATUS    , C
            GOTO    ALTB24

            MOVLW   0x7E
            ADDWF   0x1F      , W
            ADDWF   0x14      , f
            BTFSC   STATUS    , C
            GOTO    SETFOV24
            GOTO    DARGOK24
ALTB24
	    MOVLW   0x7E
            ADDWF   0x1F      , W
            ADDWF   0x14      , f
            BTFSS   STATUS    , C
            GOTO    SETFUN24
DARGOK24
	    MOVLW   0x10
            MOVWF   0x1E

DLOOP24
	    RLF     0x10      , f
            RLF     0x11      , f
            RLF     0x12      , f
            RLF     0x13      , f
            RLF     0x1F      , f

            MOVF    0x19      , W
            SUBWF   0x12      , f
            MOVF    0x1A      , W
            BTFSS   STATUS    , C
            INCFSZ  0x1A      , W
            SUBWF   0x13      , f

            RLF     0x1A      , W
            IORWF   0x1F      , f

            BTFSS   0x1F      , 00
            GOTO    DREST24

            BSF     0x10      , 00
            GOTO    DOK24
DREST24
	    MOVF    0x19      , W
            ADDWF   0x12      , f
            MOVF    0x1A      , W
            BTFSC   STATUS    , C
            INCF    0x1A      , W
            ADDWF   0x13      , f
            BCF     0x10      , 00
DOK24
	    DECFSZ  0x1E      , f
            GOTO    DLOOP24

            BTFSC   0x16      , 06
            BTFSS   0x10      , 00
            GOTO    DIV24OK
            BCF     STATUS    , C
            RLF     0x12      , f
            RLF     0x13      , f
            RLF     0x1F      , f

            MOVF    0x19      , W
            SUBWF   0x12      , f
            MOVF    0x1A      , W
            BTFSS   STATUS    , C
            INCFSZ  0x1A      , W
            SUBWF   0x13      , f

            RLF     0x1A      , W
            IORWF   0x1F      , W
            ANDLW   0x01

            ADDWF   0x10      , f
            BTFSC   STATUS    , C
            INCF    0x11      , f

            BTFSS   STATUS    , Z
            GOTO    DIV24OK
            RRF     0x11      , f
            RRF     0x10      , f
            INCF    0x14      , f
            BTFSC   STATUS    , Z
            GOTO    SETFOV24
DIV24OK
	    BTFSS   0x15      , 07
            BCF     0x11      , 07

            MOVF    0x11      , W
            MOVWF   0x13
            MOVF    0x10      , W
            MOVWF   0x12
            RETLW   0x00

SETFUN24
	    BSF     0x16      , 02
            BTFSS   0x16      , 07
            RETLW   0xFF

            MOVLW   0x01
            MOVWF   0x14
            CLRF    0x13
            CLRF    0x12
            RLF     0x15      , f
            RRF     0x13      , f
            RETLW   0xFF

SETFDZ24
	    BSF     0x16      , 03
            RETLW   0xFF

FPS24
	    MOVLW   0x80
            XORWF   0x1A      , f

            MOVF    0x13      , W
            XORWF   0x1A      , W
            MOVWF   0x1F

            CLRF    0x11
            CLRF    0x18

            MOVF    0x14      , W
            SUBWF   0x1B      , W
            BTFSS   STATUS    , C
            GOTO    USEA24

            MOVF    0x1B      , W
            MOVWF   0x0F
            MOVF    0x14      , W
            MOVWF   0x1B
            MOVF    0x0F      , W
            MOVWF   0x14

            MOVF    0x1A      , W
            MOVWF   0x0F
            MOVF    0x13      , W
            MOVWF   0x1A
            MOVF    0x0F      , W
            MOVWF   0x13

            MOVF    0x19      , W
            MOVWF   0x0F
            MOVF    0x12      , W
            MOVWF   0x19
            MOVF    0x0F      , W
            MOVWF   0x12
USEA24
	    MOVF    0x1B      , W
            BTFSC   STATUS    , Z
            RETLW   0x00

            MOVF    0x13      , W
            MOVWF   0x15
            BSF     0x13      , 07
            BSF     0x1A      , 07

            MOVF    0x1B      , W
            SUBWF   0x14      , W
            MOVWF   0x1B
            BTFSC   STATUS    , Z
            GOTO    ALIGNED24

            MOVLW   0x08
            SUBWF   0x1B      , W
            BTFSS   STATUS    , C
            GOTO    ALIGNB24
            MOVWF   0x1B
            MOVF    0x19      , W
            MOVWF   0x18
            MOVF    0x1A      , W
            MOVWF   0x19
            CLRF    0x1A

            MOVLW   0x08
            SUBWF   0x1B      , W
            BTFSS   STATUS    , C
            GOTO    ALIGNB24
            MOVF    0x15      , W
            MOVWF   0x13
            RETLW   0x00

ALIGNB24
	    MOVF    0x1B      , W
            BTFSC   STATUS    , Z
            GOTO    ALIGNED24

ALOOPB24
	    BCF     STATUS    , C
            RRF     0x1A      , f
            RRF     0x19      , f
            RRF     0x18      , f
            DECFSZ  0x1B      , f
            GOTO    ALOOPB24

ALIGNED24
	    BTFSS   0x1F      , 07
            GOTO    AOK24
            COMF    0x18      , f
            COMF    0x19      , f
            COMF    0x1A      , f
            INCF    0x18      , f
            BTFSC   STATUS    , Z
            INCF    0x19      , f
            BTFSC   STATUS    , Z
            INCF    0x1A      , f

AOK24
	    MOVF    0x18      , W
            ADDWF   0x11      , f
            MOVF    0x19      , W
            BTFSC   STATUS    , C
            INCFSZ  0x19      , W
            ADDWF   0x12      , f
            MOVF    0x1A      , W
            BTFSC   STATUS    , C
            INCFSZ  0x1A      , W
            ADDWF   0x13      , f

            BTFSC   0x1F      , 07
            GOTO    ACOMP24
            BTFSS   STATUS    , C
            GOTO    NRMRND3224

            RRF     0x13      , f
            RRF     0x12      , f
            RRF     0x11      , f
            INCFSZ  0x14      , f
            GOTO    NRMRND3224
            GOTO    SETFOV24

ACOMP24
	    BTFSC   STATUS    , C
            GOTO    NRM3224

            COMF    0x11      , f
            COMF    0x12      , f
            COMF    0x13      , f
            INCF    0x11      , f
            BTFSC   STATUS    , Z
            INCF    0x12      , f
            BTFSC   STATUS    , Z
            INCF    0x13      , f
            MOVLW   0x80
            XORWF   0x15      , f
            GOTO    NRM2424
 
            END
